@echo off

rem ****************************************************************************
rem ** 
rem ** SYNTAX: MAP [/D] [Driveletter: [Path]]
rem ** 
rem ** MAP either creates a drive letter for a path,
rem ** or removes the drive letter (if the switch /D is present).
rem **
rem ** If no drive is specified, it is taken from the definition in 
rem ** ..\setenv.bat
rem ** 
rem ** The current path is used if no path is specified
rem ** 
rem ****************************************************************************

if /i "%1" equ "/D" goto :unmap

:map
set __MAPDRIVE=%1
if "%__MAPDRIVE%" neq "" goto :map2
call "%~dp0..\setenv.bat"
set __MAPDRIVE=%DRIVE%
if "%__MAPDRIVE%" equ "" set __MAPDRIVE=S:

:map2
set __MAPDRIVE=%__MAPDRIVE:~0,1%:
set __MAPDIR=%~2
if "%__MAPDIR%" equ "" set __MAPDIR=%CD%
subst %__MAPDRIVE% /D >NUL 2>NUL
subst %__MAPDRIVE% "%__MAPDIR%" >NUL 2>NUL
if errorlevel 1 goto :eof
set __MAPHOMEDIR=%CD%
cd /d %__MAPDRIVE%\
goto :eof

:unmap
if "%2" neq "" set __MAPDRIVE=%2
if "%__MAPDRIVE%" neq "" goto :unmap2
call "%~dp0..\setenv.bat"
set __MAPDRIVE=%DRIVE%
if "%__MAPDRIVE%" equ "" set __MAPDRIVE=S:

:unmap2
set __MAPDRIVE=%__MAPDRIVE:~0,1%:
if "%__MAPHOMEDIR%" neq "" cd /d "%__MAPHOMEDIR%"
subst %__MAPDRIVE% /D >NUL 2>NUL
set __MAPDRIVE=
set __MAPDIR=
set __MAPHOMEDIR=
goto :eof
